#!/usr/bin/perl -w
use strict;
my($nexts,$fl,$fltype,$fs,$fd,$fS,$fe,$fr) = ("","/var/log/mail","","B","","","","");
my($GREP_BIN) = "/usr/bin/grep";
my(%ftf_str) = ("t","для","f","от");
my($size,$su) = ("Bytes",1);
my($SIZESALL,$count,$SIZE,$mailcount,$SIZESN,$worktime,$starttime) = 0;
my(%ID_SIZE,%ID_FTE,%ID_LOG,%ID_COUNT);
my($FILTERED_ID,$Fld,$ftf,$ID) = "";
foreach (@ARGV) {
	if ($_ eq "-l") {
		$nexts = "fl";
	} elsif ($_ eq "-f") {
		$nexts = "ff";
	} elsif ($_ eq "-t") {
		$nexts = "ft";
	} elsif ($_ eq "-r") {
		$nexts = "fr";
	} elsif ($_ eq "-s") {
		$nexts = "fs";
	} elsif ($_ eq "-d") {
		$nexts = "fd";
	} elsif ($_ eq "-S") {
		$nexts = "fS";
	} elsif ($_ eq "-h") {
		die "Используй -f|-t e-mail [-r relay] [-l logfile] [-s K|M|G] [-d \"Mmm[ D[ HH[:MM[:SS]]]]\"] [-S state] -h
			\t-l логфайл;
			\t-f|-t e-mail отправителя|получателя;
			\t-r релей (по умолчанию все);
			\t-s единица измерения размера (по умолчанию байт);
			\t-d ограничить датой (например \"Nov 2 12:00:00\");
			\t-S статус (например sent);
			\t-h вывод справки.\n";
	} else {
		if ($nexts eq "fl") {
			$fl = $_;
		} elsif ($nexts eq "ff") {
			$fe = $_; $ftf = "f";
		} elsif ($nexts eq "ft") {
			$fe = $_; $ftf = "t";
		} elsif ($nexts eq "fr") {
			$fr = $_;
		} elsif ($nexts eq "fs") {
			$fs = $_;
		} elsif ($nexts eq "fd") {
			($fd = $_) =~ s/ /  \?/;
		} elsif ($nexts eq "fS") {
			$fS = $_;
		}
		$nexts = "";
	}	
}
print "Subject: \" @ARGV\"\n";

if ($fl eq "") {
	print "Не указан лог, использую по умолчанию!\n";
	$fl = "/var/log/mail";
}
(-e $fl) || die "Ошибка, $fl не существует\n";
($fe eq "") && die "Не указан e-mail отправителя или получателя\n";

print "Поиск писем $ftf_str{$ftf} $fe в $fl";
($fd eq "") || print " с фильтром по времени: \"$fd\"";
($fS eq "") || print " с фильтром по статусу: \"$fS\"";
print "\n";

($fltype = $fl) =~ s/^.*\.//;
if ($fltype eq "gz") {
        $GREP_BIN="/usr/bin/zgrep";
} elsif ($fltype eq "bz2") {
        $GREP_BIN="/usr/bin/bzgrep";
}
if ($fs eq "K") {
        $su = 1024; $size = "K" . $size;
} elsif ($fs eq "M") {
        $su = 1048576; $size = "M" . $size;
} elsif ($fs eq "G") {
        $su = 1073741824; $size = "G" . $size;
}

print "Фильтрация лога. Это может занять некоторое время... ";
$starttime = `date +%s.%N`;

if ($ftf eq "t") {
	open(LOG,"$GREP_BIN -Ei \"^$fd.*: to=<$fe>, relay=$fr.*status=$fS\" $fl|") || die "Ошибка $!\n";
	while (<LOG>) {
			chomp;
			($Fld = (split(/  ?/))[5]) =~ s/[:,]//g;
			$ID_LOG{$Fld} .= join(" ",(split(/  ?/))[7,10,11]) . ", " . join(" ",(split(/  ?/))[0,1,2,]) . "\n";
			$FILTERED_ID .= "$Fld|" unless (defined($ID_COUNT{$Fld}));
	                $ID_COUNT{$Fld}++;
	}
} elsif ($ftf eq "f") {
	open(LOG,"$GREP_BIN -Ei \"^$fd.*: from=<$fe>\" $fl|") || die "Ошибка $!\n";
	while (<LOG>) {
	                chomp;
			($Fld = (split(/  ?/))[5]) =~ s/[:,]//g;
			($ID_SIZE{$Fld} = (split(/  ?/))[7]) =~ s/(^size=|[:,]$)//g unless (defined($ID_SIZE{$Fld}));
			$FILTERED_ID .= "$Fld|" unless (defined($ID_COUNT{$Fld}));
                	$ID_COUNT{$Fld}++;
	}
}
close(LOG);
if ($FILTERED_ID eq "") { print "Ничего не найдено.\n"; die "$!\n"; }
chop($FILTERED_ID);

if ($ftf eq "t") {
	open(LOG,"$GREP_BIN -Ei \"^$fd.*($FILTERED_ID): from=\" $fl|") || die "Ошибка $!\n";
	while (<LOG>) {
			chomp;
			($Fld = (split(/  ?/))[5]) =~ s/[:,]//g;
	                if (defined($ID_COUNT{$Fld})) {
				$ID_FTE{$Fld} = (split(/  ?/))[6] unless (defined($ID_FTE{$Fld}));
				($ID_SIZE{$Fld} = (split(/  ?/))[7]) =~ s/(^size=|[:,]$)//g unless (defined($ID_SIZE{$Fld}));
			}
	}
} elsif ($ftf eq "f") {
	open(LOG,"$GREP_BIN -Ei \"^$fd.*($FILTERED_ID): to=<.*>, relay=$fr.*status=$fS\" $fl|") || die "Ошибка $!\n";
	while (<LOG>) {
			chomp;
			($Fld = (split(/  ?/))[5]) =~ s/[:,]//g;
			if (defined($ID_COUNT{$Fld})) {
				$ID_LOG{$Fld} .= join(" ",(split(/  ?/))[7,10,11]) . ", " . join(" ",(split(/  ?/))[0,1,2]) . ", " . (split(/  ?/))[6] ."\n";
			}
	}
}
close(LOG);
print "Готово\n";

foreach $ID (keys(%ID_COUNT)) {
	$SIZE = $ID_SIZE{$ID} / $su;
	$mailcount = $ID_COUNT{$ID};
	$SIZESN = $SIZE * $mailcount;
	$SIZESALL += $SIZESN;
	(defined($ID_LOG{$ID})) || next;
	print "\nДля id=$ID:\n";
	foreach (split(/\n/, $ID_LOG{$ID})) {
		if ($ftf eq "t") {
			printf('%1$s %2$.2f %3$s',"$_, $ID_FTE{$ID} size=" , $SIZE , "$size\n");
		} elsif ($ftf eq "f") {
			printf('%1$s %2$.2f %3$s',"$_ size=" , $SIZE , "$size\n");
		}
	}
	printf('%1$s %2$.2f %3$s',"Всего найдено писем с id=$ID: $mailcount\tПолный размер:", $SIZESN, "$size\n");
	$count++;
}
$worktime = `date -d "-$starttime seconds" "+%s.%N"`;
printf('%1$s %2$.2f %3$s',"\nВсего найдено уникальных id: $count\tПолный размер:", $SIZESALL, "$size\t Затрачено времени(сек): $worktime\n");

